searchNodes=[{"doc":"Documentation for ExPassword.","ref":"ExPassword.html","title":"ExPassword","type":"module"},{"doc":"Returns the list of the modules that currently (at compile time) are enabled and provide support to ExPassword for a hashing method","ref":"ExPassword.html#available_algorithms/0","title":"ExPassword.available_algorithms/0","type":"function"},{"doc":"Extracts the options and the algorithm used to generate hash . Returns {:error, :invalid} if hash is invalid or not recognized by available_algorithms/0 .","ref":"ExPassword.html#get_options/1","title":"ExPassword.get_options/1","type":"function"},{"doc":"Hashes password using the given algorithm and options . algorithm has to be a module present in available_algorithms/0 .","ref":"ExPassword.html#hash/3","title":"ExPassword.hash/3","type":"function"},{"doc":"Returns true if the hash has not been issued by algorithm or options are different from the one used to generate hash","ref":"ExPassword.html#needs_rehash?/3","title":"ExPassword.needs_rehash?/3","type":"function"},{"doc":"Checks if password matches the given hash Raises a ExPassword.UnidentifiedAlgorithmError error if any of available_algorithms/0 recognizes hash","ref":"ExPassword.html#verify?/2","title":"ExPassword.verify?/2","type":"function"},{"doc":"This a convenient function which handles ExPassword.verify?/2 and ExPassword.needs_rehash?/3 for you (and takes care of timing attacks) Returns: {:error, :user_is_nil} : if user is nil (not found in your repo, typically after a Repo.get_by/3 operation) {:error, :password_missmatch} : if password does not match the hash in user . field {:ok, []} : if password is correct (matches the hash in user . field ) and does not need to be updated according to algorithm nor options {:ok, a non empty keyword-list} : if password is correct but needs to be updated, meaning the algorithm and/or options extracted from the hash ( user . field ) are different from algorithm and/or options to allow you to then update user 's hash A typical usage would be: # in config/* config :my_app , password_algorithm : ExPassword.Bcrypt , password_options : %{ cost : 11 } algorithm = Application . fetch_env! ( :my_app , :password_algorithm ) options = Application . fetch_env! ( :my_app , :password_options ) user = MyApp.Context.Users . get_user_by ( name : login ) case ExPassword . verify_and_rehash_if_needed ( user , password , algorithm , options ) do { :ok , changes } -&gt; if changes != [ ] do user |&gt; Ecto.Changeset . change ( changes ) |&gt; MyApp.Repo . update! ( ) end # ... (successful authentication) ... { :error , _reason } -&gt; # ... (authentication failed) ... end The case above can even be simplified if at each authentication you do additional updates like the following: case ExPassword . verify_and_rehash_if_needed ( user , password , algorithm , options , [ last_sign_in : DateTime . utc_now ( ) ] ) do { :ok , changes } -&gt; user |&gt; Ecto.Changeset . change ( changes ) |&gt; MyApp.Repo . update! ( ) # ... (successful authentication) ... { :error , _reason } -&gt; # ... (authentication failed) ... end","ref":"ExPassword.html#verify_and_rehash_if_needed/6","title":"ExPassword.verify_and_rehash_if_needed/6","type":"function"},{"doc":"","ref":"ExPassword.html#t:algorithm/0","title":"ExPassword.algorithm/0","type":"type"},{"doc":"","ref":"Mix.Tasks.ExPassword.Check.html","title":"Mix.Tasks.ExPassword.Check","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.ExPassword.Check.html#run/1","title":"Mix.Tasks.ExPassword.Check.run/1","type":"function"},{"doc":"Exception raised when no suitable algorithm were found from a hash","ref":"ExPassword.UnidentifiedAlgorithmError.html","title":"ExPassword.UnidentifiedAlgorithmError","type":"exception"}]